package examples.chat;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.RunTime;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;
import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;
// End SALSA compiler generated import delcarations.

public class Chat extends ActorReference  {
	public Chat selfReference;

	public Chat(UAN uan) { super(uan); }
	public Chat(UAL ual) { super(ual); }

	public static void main(String args[]) {
		Chat instance = new Chat();
		Message message = new Message( null, instance, "act", null );
		Object[] _arguments = { args };
		message.setArguments( _arguments );
		instance.send( message );
	}

	public Chat() {
		selfReference = this;
		State state = new State();
		ServiceFactory.getTheater().setEntry(ual, state);
	}
	public class State extends Actor {
		protected Chat self = selfReference;
		public State() {
			self.ual = __ual;
		}
		public void process(Message message) {
			Method match = getInvocationTarget(message);
			Object token = null;
			if (match != null) {
				try {
					token = match.invoke(this, message.getArguments());
				} catch (InvocationTargetException e) {
					Throwable wrapped = e.getTargetException();
					if ( !(wrapped instanceof CurrentContinuationException) ) {
						System.err.println("Message processing exception:");
						if (message.getSender() != null) {
							System.err.println("	Sent by: " + message.getSender().toString());
						} else System.err.println("	Sent by: unknown");
						System.err.println("	By actor: " + toString());
						System.err.println("	Invocation of " + message.getMethodName() + " generated a " + wrapped.getClass().getName() + " exception: " + wrapped.getMessage() );
					}
				} catch (IllegalAccessException e) {
					System.err.println("Message processing exception:");
					if (message.getSender() != null) {
						System.err.println("	Sent by: " + message.getSender().toString());
					} else System.err.println("	Sent by: unknown");
					System.err.println("	By actor: " + toString());
					System.err.println("	Illegal access exception generated by the invocation of " + message.getMethodName() + ": " + e.getMessage() );
				}
			}
			transportService.send( messages );
			messages = new Vector();
			if (currentContinuation != null) currentContinuation.resolve(message.getTarget(), token);
		}
		private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
			self.uan = this.__uan;
			self.ual = this.__ual;
			out.defaultWriteObject();
			out.flush();
		}
		private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
			in.defaultReadObject();
		}

		String myUAN;
		public void chatSession(Speaker s1, Speaker s2) {
			for (int i = 0; i < 3; i++){
				{
					Token token_3_0 = new Token();
					// s1<-talk(myUAN, "Hey what's up?  ")
					{
						Message message = new Message( self, s1, "talk", token_3_0.createInput() );
						Object _arguments[] = { myUAN, "Hey what's up?  " };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
					// s2<-talk(myUAN, "I am ok thanks!  ")
					{
						Message message = new Message( self, s2, "talk", null );
						Object _arguments[] = { myUAN, "I am ok thanks!  " };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( token_3_0.createOutput(s2, message, -1) );
						messages.add( message );
					}
				}
			}
		}
		public void reply(String replyMsg) {
			{
				// standardOutput<-println(replyMsg)
				{
					Message message = new Message( self, standardOutput, "println", null );
					Object _arguments[] = { replyMsg };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
		}
		public void act(String args[]) {
			if (args.length != 3) {
				{
					// standardOutput<-println("Usage: java examples.chat.Sender <UAN> <friendUAN> <myUAN>")
					{
						Message message = new Message( self, standardOutput, "println", null );
						Object _arguments[] = { "Usage: java examples.chat.Sender <UAN> <friendUAN> <myUAN>" };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
				}
				return;
			}
			myUAN = args[2];
			{
				// bind(myUAN)
				{
					Message message = new Message( self, self, "bind", null );
					Object _arguments[] = { myUAN };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
			Speaker speaker1 = new Speaker(new UAN(args[0]));
			Speaker speaker2 = new Speaker(new UAN(args[1]));
			{
				// chatSession(speaker1, speaker2)
				{
					Message message = new Message( self, self, "chatSession", null );
					Object _arguments[] = { speaker1, speaker2 };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
		}
	}
}