package examples.language;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.RunTime;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;
import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;
// End SALSA compiler generated import delcarations.

public class Continuation extends ActorReference  {
	public Continuation selfReference;

	public Continuation(UAN uan) { super(uan); }
	public Continuation(UAL ual) { super(ual); }

	public static void main(String args[]) {
		Continuation instance = new Continuation();
		Message message = new Message( null, instance, "act", null );
		Object[] _arguments = { args };
		message.setArguments( _arguments );
		instance.send( message );
	}

	public Continuation() {
		selfReference = this;
		State state = new State();
		ServiceFactory.getTheater().setEntry(ual, state);
	}
	public class State extends Actor {
		protected Continuation self = selfReference;
		public State() {
			self.ual = __ual;
		}
		public void process(Message message) {
			Method match = getInvocationTarget(message);
			Object token = null;
			if (match != null) {
				try {
					token = match.invoke(this, message.getArguments());
				} catch (InvocationTargetException e) {
					Throwable wrapped = e.getTargetException();
					if ( !(wrapped instanceof CurrentContinuationException) ) {
						System.err.println("Message processing exception:");
						if (message.getSender() != null) {
							System.err.println("	Sent by: " + message.getSender().toString());
						} else System.err.println("	Sent by: unknown");
						System.err.println("	By actor: " + toString());
						System.err.println("	Invocation of " + message.getMethodName() + " generated a " + wrapped.getClass().getName() + " exception: " + wrapped.getMessage() );
					}
				} catch (IllegalAccessException e) {
					System.err.println("Message processing exception:");
					if (message.getSender() != null) {
						System.err.println("	Sent by: " + message.getSender().toString());
					} else System.err.println("	Sent by: unknown");
					System.err.println("	By actor: " + toString());
					System.err.println("	Illegal access exception generated by the invocation of " + message.getMethodName() + ": " + e.getMessage() );
				}
			}
			transportService.send( messages );
			messages = new Vector();
			if (currentContinuation != null) currentContinuation.resolve(message.getTarget(), token);
		}
		private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
			self.uan = this.__uan;
			self.ual = this.__ual;
			out.defaultWriteObject();
			out.flush();
		}
		private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
			in.defaultReadObject();
		}

		public int i(int n) {
			return ++n;
		}
		public int d(int n) {
			return n * 2;
		}
		public int m(int n1, int n2) {
			return n1 * n2;
		}
		public int a(int n1, int n2) {
			return n1 + n2;
		}
		public int s(int n1, int n2) {
			return n1 - n2;
		}
		public int p(int n) {
			{
				// standardOutput<-print(n + " ")
				{
					Message message = new Message( self, standardOutput, "print", null );
					Object _arguments[] = { n + " " };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
			return n;
		}
		public void act(String[] args) {
			{
				Token token_2_0 = new Token();
				Token token_2_1 = new Token();
				Token token_2_2 = new Token();
				Token token_2_3 = new Token();
				Token token_2_4 = new Token();
				Token token_2_5 = new Token();
				Token token_2_6 = new Token();
				Token token_2_7 = new Token();
				Token token_2_8 = new Token();
				Token token_2_9 = new Token();
				Token token_2_10 = new Token();
				Token token_2_11 = new Token();
				Token token_2_12 = new Token();
				Token token_2_13 = new Token();
				Token token_2_14 = new Token();
				Token token_2_15 = new Token();
				// i(0)
				{
					Message message = new Message( self, self, "i", token_2_0.createInput() );
					Object _arguments[] = { new Integer(0) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
				// p(token)
				{
					Message message = new Message( self, self, "p", token_2_1.createInput() );
					Object _arguments[] = { token_2_0.createOutput(self, message, 0) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 1 );
					message.setInput( null );
					messages.add( message );
				}
				// d(token)
				{
					Message message = new Message( self, self, "d", token_2_2.createInput() );
					Object _arguments[] = { token_2_1.createOutput(self, message, 0) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 1 );
					message.setInput( null );
					messages.add( message );
				}
				// p(token)
				{
					Message message = new Message( self, self, "p", token_2_3.createInput() );
					Object _arguments[] = { token_2_2.createOutput(self, message, 0) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 1 );
					message.setInput( null );
					messages.add( message );
				}
				// i(token)
				{
					Message message = new Message( self, self, "i", token_2_4.createInput() );
					Object _arguments[] = { token_2_3.createOutput(self, message, 0) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 1 );
					message.setInput( null );
					messages.add( message );
				}
				// p(token)
				{
					Message message = new Message( self, self, "p", token_2_5.createInput() );
					Object _arguments[] = { token_2_4.createOutput(self, message, 0) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 1 );
					message.setInput( null );
					messages.add( message );
				}
				// d(token)
				{
					Message message = new Message( self, self, "d", token_2_6.createInput() );
					Object _arguments[] = { token_2_5.createOutput(self, message, 0) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 1 );
					message.setInput( null );
					messages.add( message );
				}
				// p(token)
				{
					Message message = new Message( self, self, "p", token_2_7.createInput() );
					Object _arguments[] = { token_2_6.createOutput(self, message, 0) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 1 );
					message.setInput( null );
					messages.add( message );
				}
				// i(token)
				{
					Message message = new Message( self, self, "i", token_2_8.createInput() );
					Object _arguments[] = { token_2_7.createOutput(self, message, 0) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 1 );
					message.setInput( null );
					messages.add( message );
				}
				// p(token)
				{
					Message message = new Message( self, self, "p", token_2_9.createInput() );
					Object _arguments[] = { token_2_8.createOutput(self, message, 0) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 1 );
					message.setInput( null );
					messages.add( message );
				}
				// m(token, 10)
				{
					Message message = new Message( self, self, "m", token_2_10.createInput() );
					Object _arguments[] = { token_2_9.createOutput(self, message, 0), new Integer(10) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 1 );
					message.setInput( null );
					messages.add( message );
				}
				// p(token)
				{
					Message message = new Message( self, self, "p", token_2_11.createInput() );
					Object _arguments[] = { token_2_10.createOutput(self, message, 0) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 1 );
					message.setInput( null );
					messages.add( message );
				}
				// a(3, token)
				{
					Message message = new Message( self, self, "a", token_2_12.createInput() );
					Object _arguments[] = { new Integer(3), token_2_11.createOutput(self, message, 1) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 1 );
					message.setInput( null );
					messages.add( message );
				}
				// p(token)
				{
					Message message = new Message( self, self, "p", token_2_13.createInput() );
					Object _arguments[] = { token_2_12.createOutput(self, message, 0) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 1 );
					message.setInput( null );
					messages.add( message );
				}
				// s(token, 1)
				{
					Message message = new Message( self, self, "s", token_2_14.createInput() );
					Object _arguments[] = { token_2_13.createOutput(self, message, 0), new Integer(1) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 1 );
					message.setInput( null );
					messages.add( message );
				}
				// p(token)
				{
					Message message = new Message( self, self, "p", token_2_15.createInput() );
					Object _arguments[] = { token_2_14.createOutput(self, message, 0) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 1 );
					message.setInput( null );
					messages.add( message );
				}
				// standardOutput<-print("hi")
				{
					Message message = new Message( self, standardOutput, "print", null );
					Object _arguments[] = { "hi" };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( token_2_15.createOutput(standardOutput, message, -1) );
					messages.add( message );
				}
			}
		}
	}
}