package examples.language;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.RunTime;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;
import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;
// End SALSA compiler generated import delcarations.

public class CurrentContinuation extends ActorReference  {
	public CurrentContinuation selfReference;

	public CurrentContinuation(UAN uan) { super(uan); }
	public CurrentContinuation(UAL ual) { super(ual); }

	public static void main(String args[]) {
		CurrentContinuation instance = new CurrentContinuation();
		Message message = new Message( null, instance, "act", null );
		Object[] _arguments = { args };
		message.setArguments( _arguments );
		instance.send( message );
	}

	public CurrentContinuation() {
		selfReference = this;
		State state = new State();
		ServiceFactory.getTheater().setEntry(ual, state);
	}
	public class State extends Actor {
		protected CurrentContinuation self = selfReference;
		public State() {
			self.ual = __ual;
		}
		public void process(Message message) {
			Method match = getInvocationTarget(message);
			Object token = null;
			if (match != null) {
				try {
					token = match.invoke(this, message.getArguments());
				} catch (InvocationTargetException e) {
					Throwable wrapped = e.getTargetException();
					if ( !(wrapped instanceof CurrentContinuationException) ) {
						System.err.println("Message processing exception:");
						if (message.getSender() != null) {
							System.err.println("	Sent by: " + message.getSender().toString());
						} else System.err.println("	Sent by: unknown");
						System.err.println("	By actor: " + toString());
						System.err.println("	Invocation of " + message.getMethodName() + " generated a " + wrapped.getClass().getName() + " exception: " + wrapped.getMessage() );
					}
				} catch (IllegalAccessException e) {
					System.err.println("Message processing exception:");
					if (message.getSender() != null) {
						System.err.println("	Sent by: " + message.getSender().toString());
					} else System.err.println("	Sent by: unknown");
					System.err.println("	By actor: " + toString());
					System.err.println("	Illegal access exception generated by the invocation of " + message.getMethodName() + ": " + e.getMessage() );
				}
			}
			transportService.send( messages );
			messages = new Vector();
			if (currentContinuation != null) currentContinuation.resolve(message.getTarget(), token);
		}
		private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
			self.uan = this.__uan;
			self.ual = this.__ual;
			out.defaultWriteObject();
			out.flush();
		}
		private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
			in.defaultReadObject();
		}

		public int compute() {
			{
				// add(4, 1)
				{
					Message message = new Message( self, self, "add", currentContinuation );
					Object _arguments[] = { new Integer(4), new Integer(1) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
				currentContinuation = null;
				throw new CurrentContinuationException();
			}
		}
		public int add(int n1, int n2) {
			return n1 + n2;
		}
		public void act(String args[]) {
			{
				Token token_2_0 = new Token();
				// compute()
				{
					Message message = new Message( self, self, "compute", token_2_0.createInput() );
					Object _arguments[] = {  };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
				// standardOutput<-println(token)
				{
					Message message = new Message( self, standardOutput, "println", null );
					Object _arguments[] = { token_2_0.createOutput(standardOutput, message, 0) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 1 );
					message.setInput( null );
					messages.add( message );
				}
			}
			{
				Token token_2_0 = new Token();
				Token token_2_1 = new Token();
				// compute()
				{
					Message message = new Message( self, self, "compute", token_2_0.createInput() );
					Object _arguments[] = {  };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
				// add(token, 2)
				{
					Message message = new Message( self, self, "add", token_2_1.createInput() );
					Object _arguments[] = { token_2_0.createOutput(self, message, 0), new Integer(2) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 1 );
					message.setInput( null );
					messages.add( message );
				}
				// standardOutput<-println(token)
				{
					Message message = new Message( self, standardOutput, "println", null );
					Object _arguments[] = { token_2_1.createOutput(standardOutput, message, 0) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 1 );
					message.setInput( null );
					messages.add( message );
				}
			}
		}
	}
}