package examples.trap;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.RunTime;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;
import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;
// End SALSA compiler generated import delcarations.

import java.io.*;
public class TrapWorker extends ActorReference  {
	public TrapWorker selfReference;

	public TrapWorker(UAN uan) { super(uan); }
	public TrapWorker(UAL ual) { super(ual); }

	public static void main(String args[]) {
		TrapWorker instance = new TrapWorker();
		Message message = new Message( null, instance, "act", null );
		Object[] _arguments = { args };
		message.setArguments( _arguments );
		instance.send( message );
	}

	public TrapWorker() {
		selfReference = this;
		State state = new State();
		ServiceFactory.getTheater().setEntry(ual, state);
	}
	public class State extends Actor {
		protected TrapWorker self = selfReference;
		public State() {
			self.ual = __ual;
		}
		public void process(Message message) {
			Method match = getInvocationTarget(message);
			Object token = null;
			if (match != null) {
				try {
					token = match.invoke(this, message.getArguments());
				} catch (InvocationTargetException e) {
					Throwable wrapped = e.getTargetException();
					if ( !(wrapped instanceof CurrentContinuationException) ) {
						System.err.println("Message processing exception:");
						if (message.getSender() != null) {
							System.err.println("	Sent by: " + message.getSender().toString());
						} else System.err.println("	Sent by: unknown");
						System.err.println("	By actor: " + toString());
						System.err.println("	Invocation of " + message.getMethodName() + " generated a " + wrapped.getClass().getName() + " exception: " + wrapped.getMessage() );
					}
				} catch (IllegalAccessException e) {
					System.err.println("Message processing exception:");
					if (message.getSender() != null) {
						System.err.println("	Sent by: " + message.getSender().toString());
					} else System.err.println("	Sent by: unknown");
					System.err.println("	By actor: " + toString());
					System.err.println("	Illegal access exception generated by the invocation of " + message.getMethodName() + ": " + e.getMessage() );
				}
			}
			transportService.send( messages );
			messages = new Vector();
			if (currentContinuation != null) currentContinuation.resolve(message.getTarget(), token);
		}
		private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
			self.uan = this.__uan;
			self.ual = this.__ual;
			out.defaultWriteObject();
			out.flush();
		}
		private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
			in.defaultReadObject();
		}

		public Double trap(Double local_a, Double local_b, Integer local_n, Double h) {
			Token f_local_a = new Token("f_local_a");
			{
				// token f_local_a = f(local_a)
				{
					Message message = new Message( self, self, "f", f_local_a.createInput() );
					Object _arguments[] = { local_a };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
			Token f_local_b = new Token("f_local_b");
			{
				// token f_local_b = f(local_b)
				{
					Message message = new Message( self, self, "f", f_local_b.createInput() );
					Object _arguments[] = { local_b };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
			Token integral = new Token("integral");
			{
				// token integral = startIntegral(f_local_a, f_local_b)
				{
					Message message = new Message( self, self, "startIntegral", integral.createInput() );
					Object _arguments[] = { f_local_a.createOutput(self, message, 0), f_local_b.createOutput(self, message, 1) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 2 );
					message.setInput( null );
					messages.add( message );
				}
			}
			double x = local_a.doubleValue();
			for (int i = 1; i <= local_n.intValue() - 1; i++, x += h.doubleValue()){
				Token f_x = new Token("f_x");
				{
					// token f_x = f(new Double(x))
					{
						Message message = new Message( self, self, "f", f_x.createInput() );
						Object _arguments[] = { new Double(x) };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
				}
				{
					// integral = add(integral, f_x)
					Token integral_next = new Token("add_next");
					{
						Message message = new Message( self, self, "add", integral_next.createInput() );
						Object _arguments[] = { integral.createOutput(self, message, 0), f_x.createOutput(self, message, 1) };
						message.setArguments( _arguments );
						message.setRequiredTokens( 2 );
						message.setInput( null );
						messages.add( message );
					}
					integral = integral_next;
				}
			}
			{
				// multiply(integral, h)
				{
					Message message = new Message( self, self, "multiply", currentContinuation );
					Object _arguments[] = { integral.createOutput(self, message, 0), h };
					message.setArguments( _arguments );
					message.setRequiredTokens( 1 );
					message.setInput( null );
					messages.add( message );
				}
				currentContinuation = null;
				throw new CurrentContinuationException();
			}
		}
		public Double f(Double d) {
			double dv = d.doubleValue();
			return new Double(5 * dv * dv * dv * dv);
		}
		public Double add(Double d, Double f) {
			double dv = d.doubleValue();
			double fv = f.doubleValue();
			return new Double(dv + fv);
		}
		public Double multiply(Double d, Double f) {
			double dv = d.doubleValue();
			double fv = f.doubleValue();
			return new Double(dv * fv);
		}
		public Double startIntegral(Double d, Double f) {
			return new Double((d.doubleValue() + f.doubleValue()) / 2.0);
		}
	}
}