package io.ars;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.RunTime;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;
import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;
// End SALSA compiler generated import delcarations.

import java.util.Vector;
import io.IOTheater;
import io.core.agents.ProfilingAgent;
import io.resources.PeerServer;
public class ARSProtocolActor extends ActorReference  {
	public ARSProtocolActor selfReference;

	public ARSProtocolActor(UAN uan) { super(uan); }
	public ARSProtocolActor(UAL ual) { super(ual); }

	public static void main(String args[]) {
		ARSProtocolActor instance = new ARSProtocolActor();
		Message message = new Message( null, instance, "act", null );
		Object[] _arguments = { args };
		message.setArguments( _arguments );
		instance.send( message );
	}

	public ARSProtocolActor() {
		selfReference = this;
		State state = new State();
		ServiceFactory.getTheater().setEntry(ual, state);
	}
	public class State extends Actor {
		protected ARSProtocolActor self = selfReference;
		public void process(Message message) {
			Method match = getInvocationTarget(message);
			Object token = null;
			if (match != null) {
				try {
					token = match.invoke(this, message.getArguments());
				} catch (InvocationTargetException e) {
					Throwable wrapped = e.getTargetException();
					if ( !(wrapped instanceof CurrentContinuationException) ) {
						System.err.println("Message processing exception:");
						if (message.getSender() != null) {
							System.err.println("	Sent by: " + message.getSender().toString());
						} else System.err.println("	Sent by: unknown");
						System.err.println("	By actor: " + toString());
						System.err.println("	Invocation of " + message.getMethodName() + " generated a " + wrapped.getClass().getName() + " exception: " + wrapped.getMessage() );
					}
				} catch (IllegalAccessException e) {
					System.err.println("Message processing exception:");
					if (message.getSender() != null) {
						System.err.println("	Sent by: " + message.getSender().toString());
					} else System.err.println("	Sent by: unknown");
					System.err.println("	By actor: " + toString());
					System.err.println("	Illegal access exception generated by the invocation of " + message.getMethodName() + ": " + e.getMessage() );
				}
			}
			transportService.send( messages );
			messages = new Vector();
			if (currentContinuation != null) currentContinuation.resolve(message.getTarget(), token);
		}
		private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
			self.uan = this.__uan;
			self.ual = this.__ual;
			out.defaultWriteObject();
			out.flush();
		}
		private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
			in.defaultReadObject();
		}

		ActorReference decisionActor = null;
		ARSProfilingAgent profilingAgent = (ARSProfilingAgent) IOTheater.getProfilingAgent();
		boolean connected = true;
		Vector neighbors = new Vector();
		Vector peerServers = new Vector();
		int maxTTL = 5;
		int maxPeers = 10;
		State() {
			self.ual = __ual;
			Vector messages = new Vector();

			this.reName("/system/protocolActor");
			String connection = System.getProperty("connection");
			if (connection != null) {
				try {
					UAL ual = new UAL(connection);
					if (ual.getIdentifier().equals("/system/peerServer")) {
						{
							// joinComputation(new PeerServer(ual))
							{
								Message message = new Message( self, self, "joinComputation", null );
								Object _arguments[] = { new PeerServer(ual) };
								message.setArguments( _arguments );
								message.setRequiredTokens( 0 );
								message.setInput( null );
								messages.add( message );
							}
						}
					}
					else {
						{
							// joinComputation(new ARSProtocolActor(ual))
							{
								Message message = new Message( self, self, "joinComputation", null );
								Object _arguments[] = { new ARSProtocolActor(ual) };
								message.setArguments( _arguments );
								message.setRequiredTokens( 0 );
								message.setInput( null );
								messages.add( message );
							}
						}
					}
				}
				catch (MalformedUALException e) {
					System.err.println("Improperly specified system property: " + connection);
					System.err.println("Malformed UAL Exception: " + e);
				}

			}
			ServiceFactory.getTransport().send(messages);
		}
		public void initiateSteal(double processing) {
			profilingAgent.setWaiting(true);
			{
				Token token_2_0 = new Token();
				// propagateSteal(self, new Double(processing), new Integer(maxTTL))
				{
					Message message = new Message( self, self, "propagateSteal", token_2_0.createInput() );
					Object _arguments[] = { self, new Double(processing), new Integer(maxTTL) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
				// stealFinished()
				{
					Message message = new Message( self, self, "stealFinished", null );
					Object _arguments[] = {  };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( token_2_0.createOutput(self, message, -1) );
					messages.add( message );
				}
			}
		}
		public void stealFinished() {
			profilingAgent.setWaiting(false);
		}
		public void steal(ARSProtocolActor source, double processing, int timeToLive) {
			if (!neighbors.contains(source)) neighbors.add(source);
			if (decisionActor == null) decisionActor = IOTheater.getDecisionActor();
			Token candidate = new Token("candidate");
			{
				// token candidate = decisionActor<-getBestCandidate(source.getUAL(), new Double(processing))
				{
					Message message = new Message( self, decisionActor, "getBestCandidate", candidate.createInput() );
					Object _arguments[] = { source.getUAL(), new Double(processing) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
			{
				// resolveSteal(candidate, source, new Double(processing), new Integer(timeToLive))
				{
					Message message = new Message( self, self, "resolveSteal", currentContinuation );
					Object _arguments[] = { candidate.createOutput(self, message, 0), source, new Double(processing), new Integer(timeToLive) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 1 );
					message.setInput( null );
					messages.add( message );
				}
				currentContinuation = null;
				throw new CurrentContinuationException();
			}
		}
		public void resolveSteal(ActorReference candidate, ARSProtocolActor source, double processing, int timeToLive) {
			if (candidate == null) {
				{
					// propagateSteal(source, new Double(processing), new Integer(timeToLive))
					{
						Message message = new Message( self, self, "propagateSteal", currentContinuation );
						Object _arguments[] = { source, new Double(processing), new Integer(timeToLive) };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
					currentContinuation = null;
					throw new CurrentContinuationException();
				}
			}
			else {
				{
					// candidate<-migrate(new UAL(source.getUAL().getLocation() + candidate.getUAN().getIdentifier()))
					{
						Message message = new Message( self, candidate, "migrate", currentContinuation );
						Object _arguments[] = { new UAL(source.getUAL().getLocation() + candidate.getUAN().getIdentifier()) };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						Object[] _propertyInfo = {  };
						message.setProperty( "priority", _propertyInfo );
						messages.add( message );
					}
					currentContinuation = null;
					throw new CurrentContinuationException();
				}
			}
		}
		public void propagateSteal(ARSProtocolActor source, double processing, int timeToLive) {
			if (neighbors.contains(source) && neighbors.size() == 1) {
				return;
			}
			if (neighbors.size() == 0) 			return;
			timeToLive--;
			if (timeToLive > maxTTL) timeToLive = maxTTL - 1;
			if (timeToLive < 0) 			return;
			ARSProtocolActor target = (ARSProtocolActor) neighbors.get((int) java.lang.Math.random() * neighbors.size());
			while (target.equals(source)) {
				target = (ARSProtocolActor) neighbors.get((int) java.lang.Math.random() * neighbors.size());
			}
			{
				// target<-steal(source, new Double(processing), new Integer(timeToLive))
				{
					Message message = new Message( self, target, "steal", currentContinuation );
					Object _arguments[] = { source, new Double(processing), new Integer(timeToLive) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
				currentContinuation = null;
				throw new CurrentContinuationException();
			}
		}
		public void joinComputation(PeerServer peerServer) {
			profilingAgent.setComputing(true);
			peerServers.add(peerServer);
			{
				// peerServer<-register(self)
				{
					Message message = new Message( self, peerServer, "register", null );
					Object _arguments[] = { self };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
			{
				Token token_2_0 = new Token();
				// peerServer<-getPeers(new Integer(maxPeers))
				{
					Message message = new Message( self, peerServer, "getPeers", token_2_0.createInput() );
					Object _arguments[] = { new Integer(maxPeers) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
				// addNeighbors(token)
				{
					Message message = new Message( self, self, "addNeighbors", null );
					Object _arguments[] = { token_2_0.createOutput(self, message, 0) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 1 );
					message.setInput( null );
					messages.add( message );
				}
			}
		}
		public void addNeighbors(Vector neighbors) {
			if (neighbors == null) 			return;
			for (int i = 0; i < neighbors.size(); i++){
				if (!this.equals((ActorReference) neighbors.get(i)) && !this.neighbors.contains((ActorReference) neighbors.get(i))) {
					this.neighbors.add(neighbors.get(i));
				}
			}
		}
		public void joinComputation(ARSProtocolActor neighbor) {
			profilingAgent.setComputing(true);
			neighbors.add(neighbor);
		}
		Vector unmigratedActors = null;
		public void leaveComputation() {
			profilingAgent.setComputing(false);
			if (System.getProperty("silent") == null) System.err.println("leaving!");
			for (int i = 0; i < peerServers.size(); i++){
				PeerServer target = (PeerServer) peerServers.get(i);
				peerServers.remove(target);
				{
					// target<-remove(self)
					{
						Message message = new Message( self, target, "remove", null );
						Object _arguments[] = { self };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
				}
			}
			unmigratedActors = profilingAgent.getActorReferences();
			if (neighbors == null || neighbors.size() == 0) {
				{
					// purge()
					{
						Message message = new Message( self, self, "purge", null );
						Object _arguments[] = {  };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
				}
			}
			else {
				for (int i = 0; i < neighbors.size(); i++){
					ARSProtocolActor target = (ARSProtocolActor) neighbors.get(i);
					{
						// target<-leaveRequest(self)
						{
							Message message = new Message( self, target, "leaveRequest", null );
							Object _arguments[] = { self };
							message.setArguments( _arguments );
							message.setRequiredTokens( 0 );
							message.setInput( null );
							messages.add( message );
						}
					}
				}
			}
		}
		public void leaveRequest(ARSProtocolActor requester) {
			neighbors.remove(requester);
			if (profilingAgent.isComputing()) 			{
				// requester<-getActor(self)
				{
					Message message = new Message( self, requester, "getActor", null );
					Object _arguments[] = { self };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
			else 			{
				// requester<-notConnected(self)
				{
					Message message = new Message( self, requester, "notConnected", null );
					Object _arguments[] = { self };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
		}
		public void notConnected(ARSProtocolActor neighbor) {
			neighbors.remove(neighbor);
			if (neighbors.size() == 0) 			{
				// purge()
				{
					Message message = new Message( self, self, "purge", null );
					Object _arguments[] = {  };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
		}
		public void getActor(ARSProtocolActor requester) {
			if (unmigratedActors.size() > 0) {
				ActorReference target = (ActorReference) unmigratedActors.get(0);
				unmigratedActors.remove(0);
				{
					// target<-migrate(requester.getUAL().getLocation() + target.getUAN().getIdentifier())
					{
						Message message = new Message( self, target, "migrate", null );
						Object _arguments[] = { requester.getUAL().getLocation() + target.getUAN().getIdentifier() };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						Object[] _propertyInfo = {  };
						message.setProperty( "priority", _propertyInfo );
						messages.add( message );
					}
				}
				if (unmigratedActors.size() > 0) 				{
					// requester<-leaveRequest(self)
					{
						Message message = new Message( self, requester, "leaveRequest", null );
						Object _arguments[] = { self };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						messages.add( message );
					}
				}
			}
		}
		public void purge() {
			if (System.getProperty("silent") == null) System.err.println("purging!");
			Vector actors = profilingAgent.getActorReferences();
			for (int i = 0; i < actors.size(); i++){
				ActorReference target = (ActorReference) actors.get(i);
				{
					// target<-destroy()
					{
						Message message = new Message( self, target, "destroy", null );
						Object _arguments[] = {  };
						message.setArguments( _arguments );
						message.setRequiredTokens( 0 );
						message.setInput( null );
						Object[] _propertyInfo = {  };
						message.setProperty( "priority", _propertyInfo );
						messages.add( message );
					}
				}
			}
		}
		public String status() {
			String status = "";
			status += "\tTheater: " + getUAL().getLocation() + "\n";
			status += "\tTheater connected: " + profilingAgent.isComputing() + "\n";
			status += "\tTotal messages processed: " + profilingAgent.totalProcessed() + "\n";
			status += "\tProcessed since last reset: " + profilingAgent.processed() + "\n";
			status += "\tNumber of autonomous actors: " + profilingAgent.getActorProfiles().size();
			return status;
		}
	}
}