package io.core.language;

import salsa.language.Actor;
import salsa.language.Message;
import salsa.naming.UAN;

import io.IOTheater;
import io.core.agents.ProfilingAgent;

public class AutonomousActor extends Actor {
	private transient ProfilingAgent profilingAgent;

	public AutonomousActor() {
		super();

		profilingAgent = IOTheater.getProfilingAgent();
		profilingAgent.actorEnter(getIdentifier());
	}

	private String getIdentifier() {
		if (__uan == null)	return __ual.toString();
		else			return __uan.toString();
	}

	public synchronized void bind(UAN uan) {
		profilingAgent.updateIdentifier(uan.toString(), __ual.toString());
		super.bind(uan);
	}

	public synchronized void send(Message message) {
		profilingAgent.received(getIdentifier(), message);
		super.send(message);
	}

	public void process(Message message) {
		profilingAgent.beginProcessed(getIdentifier());
		super.process(message);
		profilingAgent.endProcessed(getIdentifier());
	}

	public void destroy() {
		profilingAgent.actorExit(getIdentifier());
		super.destroy();
	}

	private void writeObject(java.io.ObjectOutputStream out) throws Exception {
		profilingAgent.actorExit(getIdentifier());
		out.defaultWriteObject();
	}

	private void readObject(java.io.ObjectInputStream in) throws Exception {
		in.defaultReadObject();

		profilingAgent = IOTheater.getProfilingAgent();
		profilingAgent.actorEnter(getIdentifier());
	}
}
