package io.resources;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.RunTime;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;
import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;
// End SALSA compiler generated import delcarations.

public class PeerServer extends ActorReference  {
	public PeerServer selfReference;

	public PeerServer(UAN uan) { super(uan); }
	public PeerServer(UAL ual) { super(ual); }

	public static void main(String args[]) {
		PeerServer instance = new PeerServer();
		Message message = new Message( null, instance, "act", null );
		Object[] _arguments = { args };
		message.setArguments( _arguments );
		instance.send( message );
	}

	public PeerServer() {
		selfReference = this;
		State state = new State();
		ServiceFactory.getTheater().setEntry(ual, state);
	}
	public class State extends Actor {
		protected PeerServer self = selfReference;
		public void process(Message message) {
			Method match = getInvocationTarget(message);
			Object token = null;
			if (match != null) {
				try {
					token = match.invoke(this, message.getArguments());
				} catch (InvocationTargetException e) {
					Throwable wrapped = e.getTargetException();
					if ( !(wrapped instanceof CurrentContinuationException) ) {
						System.err.println("Message processing exception:");
						if (message.getSender() != null) {
							System.err.println("	Sent by: " + message.getSender().toString());
						} else System.err.println("	Sent by: unknown");
						System.err.println("	By actor: " + toString());
						System.err.println("	Invocation of " + message.getMethodName() + " generated a " + wrapped.getClass().getName() + " exception: " + wrapped.getMessage() );
					}
				} catch (IllegalAccessException e) {
					System.err.println("Message processing exception:");
					if (message.getSender() != null) {
						System.err.println("	Sent by: " + message.getSender().toString());
					} else System.err.println("	Sent by: unknown");
					System.err.println("	By actor: " + toString());
					System.err.println("	Illegal access exception generated by the invocation of " + message.getMethodName() + ": " + e.getMessage() );
				}
			}
			transportService.send( messages );
			messages = new Vector();
			if (currentContinuation != null) currentContinuation.resolve(message.getTarget(), token);
		}
		private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
			self.uan = this.__uan;
			self.ual = this.__ual;
			out.defaultWriteObject();
			out.flush();
		}
		private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
			in.defaultReadObject();
		}

		Vector peers = new Vector();
		State() {
			self.ual = __ual;
			Vector messages = new Vector();

			this.reName("/system/peerServer");
			ServiceFactory.getTransport().send(messages);
		}
		public void act(String[] arguments) {
			{
				// standardOutput<-println("PeerServer listening at UAL: " + getUAL())
				{
					Message message = new Message( self, standardOutput, "println", null );
					Object _arguments[] = { "PeerServer listening at UAL: " + getUAL() };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
		}
		public void remove(ActorReference peer) {
			{
				// standardOutput<-println("\tRemoving from registry: " + peer.getUAL().toString())
				{
					Message message = new Message( self, standardOutput, "println", null );
					Object _arguments[] = { "\tRemoving from registry: " + peer.getUAL().toString() };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
			peers.remove(peer);
		}
		public void register(ActorReference peer) {
			{
				// standardOutput<-println("\tAdding to registry: " + peer.getUAL().toString())
				{
					Message message = new Message( self, standardOutput, "println", null );
					Object _arguments[] = { "\tAdding to registry: " + peer.getUAL().toString() };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
			if (!peers.contains(peer)) peers.add(peer);
		}
		public Vector getPeers(int maxPeers) {
			{
				// standardOutput<-println("\tReceived request for " + maxPeers + " actors.")
				{
					Message message = new Message( self, standardOutput, "println", null );
					Object _arguments[] = { "\tReceived request for " + maxPeers + " actors." };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
			if (peers.size() == 0) 			return null;
			Vector peersToSend = new Vector();
			for (int i = 0; i < maxPeers; i++){
				peersToSend.add(peers.get((int) (java.lang.Math.random() * peers.size())));
			}
			return peers;
		}
		public String purgeAll() {
			{
				// standardOutput<-println("\tPurging the entire computation.")
				{
					Message message = new Message( self, standardOutput, "println", null );
					Object _arguments[] = { "\tPurging the entire computation." };
					message.setArguments( _arguments );
					message.setRequiredTokens( 0 );
					message.setInput( null );
					messages.add( message );
				}
			}
			{
				Token token_2_0 = new Token();
				// join block
				token_2_0.setJoinToken();
				if (peers.size() == 0) 				return "No connected theaters.\n";
				for (int i = 0; i < peers.size(); i++){
					ActorReference target = (ActorReference) peers.get(i);
					{
						Token token_4_0 = new Token();
						// target<-purge()
						{
							Message message = new Message( self, target, "purge", token_4_0.createInput() );
							Object _arguments[] = {  };
							message.setArguments( _arguments );
							message.setRequiredTokens( 0 );
							message.setInput( null );
							messages.add( message );
						}
						// standardOutput<-println("\t\tPurged: " + target.getUAL().toString())
						{
							Message message = new Message( self, standardOutput, "println", token_2_0.createInput() );
							Object _arguments[] = { "\t\tPurged: " + target.getUAL().toString() };
							message.setArguments( _arguments );
							message.setRequiredTokens( 0 );
							message.setInput( token_4_0.createOutput(standardOutput, message, -1) );
							messages.add( message );
						}
					}
				}
				// combine(token)
				{
					Message message = new Message( self, self, "combine", currentContinuation );
					Object _arguments[] = { token_2_0.createOutput(self, message, 0) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 1 );
					message.setInput( null );
					messages.add( message );
				}
				currentContinuation = null;
				throw new CurrentContinuationException();
			}
		}
		public String statusAll() {
			{
				Token token_2_0 = new Token();
				// join block
				token_2_0.setJoinToken();
				if (peers.size() == 0) 				return "No connected theaters.\n";
				for (int i = 0; i < peers.size(); i++){
					ActorReference target = (ActorReference) peers.get(i);
					{
						// target<-status()
						{
							Message message = new Message( self, target, "status", token_2_0.createInput() );
							Object _arguments[] = {  };
							message.setArguments( _arguments );
							message.setRequiredTokens( 0 );
							message.setInput( null );
							messages.add( message );
						}
					}
				}
				// combine(token)
				{
					Message message = new Message( self, self, "combine", currentContinuation );
					Object _arguments[] = { token_2_0.createOutput(self, message, 0) };
					message.setArguments( _arguments );
					message.setRequiredTokens( 1 );
					message.setInput( null );
					messages.add( message );
				}
				currentContinuation = null;
				throw new CurrentContinuationException();
			}
		}
		public String combine(Object[] results) {
			String statusAll = "";
			for (int i = 0; i < results.length; i++){
				statusAll += (String) results[i] + "\n\n";
			}
			return statusAll;
		}
	}
}